# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2014_04_01
  module Models
    #
    # The database edition capabilities.
    #
    class EditionCapability

      include MsRestAzure

      # @return [String] The edition name.
      attr_accessor :name

      # @return [CapabilityStatus] The status of the edition. Possible values
      # include: 'Visible', 'Available', 'Default', 'Disabled'
      attr_accessor :status

      # @return [Array<ServiceObjectiveCapability>] The list of supported
      # service objectives for the edition.
      attr_accessor :supported_service_level_objectives

      # @return [Boolean] Whether or not zone redundancy is supported for the
      # edition.
      attr_accessor :zone_redundant


      #
      # Mapper for EditionCapability class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EditionCapability',
          type: {
            name: 'Composite',
            class_name: 'EditionCapability',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'Enum',
                  module: 'CapabilityStatus'
                }
              },
              supported_service_level_objectives: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'supportedServiceLevelObjectives',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ServiceObjectiveCapabilityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ServiceObjectiveCapability'
                      }
                  }
                }
              },
              zone_redundant: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'zoneRedundant',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
