# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2014_04_01
  module Models
    #
    # Represents a server firewall rule.
    #
    class FirewallRule < ProxyResource

      include MsRestAzure

      # @return [String] Kind of server that contains this firewall rule.
      attr_accessor :kind

      # @return [String] Location of the server that contains this firewall
      # rule.
      attr_accessor :location

      # @return [String] The start IP address of the firewall rule. Must be
      # IPv4 format. Use value '0.0.0.0' to represent all Azure-internal IP
      # addresses.
      attr_accessor :start_ip_address

      # @return [String] The end IP address of the firewall rule. Must be IPv4
      # format. Must be greater than or equal to startIpAddress. Use value
      # '0.0.0.0' to represent all Azure-internal IP addresses.
      attr_accessor :end_ip_address


      #
      # Mapper for FirewallRule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FirewallRule',
          type: {
            name: 'Composite',
            class_name: 'FirewallRule',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              start_ip_address: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.startIpAddress',
                type: {
                  name: 'String'
                }
              },
              end_ip_address: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.endIpAddress',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
