# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2015_05_01_preview
  module Models
    #
    # Contains information for manual implementation for an Azure SQL Database,
    # Server or Elastic Pool Recommended Action.
    #
    class RecommendedActionImplementationInfo

      include MsRestAzure

      # @return [ImplementationMethod] Gets the method in which this
      # recommended action can be manually implemented. e.g., TSql,
      # AzurePowerShell. Possible values include: 'TSql', 'AzurePowerShell'
      attr_accessor :method

      # @return [String] Gets the manual implementation script. e.g., T-SQL
      # script that could be executed on the database.
      attr_accessor :script


      #
      # Mapper for RecommendedActionImplementationInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RecommendedActionImplementationInfo',
          type: {
            name: 'Composite',
            class_name: 'RecommendedActionImplementationInfo',
            model_properties: {
              method: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'method',
                type: {
                  name: 'Enum',
                  module: 'ImplementationMethod'
                }
              },
              script: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'script',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
