# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2017_10_01_preview
  module Models
    #
    # The max per-database performance level capability.
    #
    class ElasticPoolPerDatabaseMaxPerformanceLevelCapability

      include MsRestAzure

      # @return [Float] The maximum performance level per database.
      attr_accessor :limit

      # @return [PerformanceLevelUnit] Unit type used to measure performance
      # level. Possible values include: 'DTU', 'VCores'
      attr_accessor :unit

      # @return [Array<ElasticPoolPerDatabaseMinPerformanceLevelCapability>]
      # The list of supported min database performance levels.
      attr_accessor :supported_per_database_min_performance_levels

      # @return [CapabilityStatus] The status of the capability. Possible
      # values include: 'Visible', 'Available', 'Default', 'Disabled'
      attr_accessor :status

      # @return [String] The reason for the capability not being available.
      attr_accessor :reason


      #
      # Mapper for ElasticPoolPerDatabaseMaxPerformanceLevelCapability class as
      # Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ElasticPoolPerDatabaseMaxPerformanceLevelCapability',
          type: {
            name: 'Composite',
            class_name: 'ElasticPoolPerDatabaseMaxPerformanceLevelCapability',
            model_properties: {
              limit: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'limit',
                type: {
                  name: 'Double'
                }
              },
              unit: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'unit',
                type: {
                  name: 'String'
                }
              },
              supported_per_database_min_performance_levels: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'supportedPerDatabaseMinPerformanceLevels',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ElasticPoolPerDatabaseMinPerformanceLevelCapabilityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ElasticPoolPerDatabaseMinPerformanceLevelCapability'
                      }
                  }
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'Enum',
                  module: 'CapabilityStatus'
                }
              },
              reason: {
                client_side_validation: true,
                required: false,
                serialized_name: 'reason',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
