# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2017_10_01_preview
  module Models
    #
    # An elastic pool update.
    #
    class ElasticPoolUpdate

      include MsRestAzure

      # @return [Sku]
      attr_accessor :sku

      # @return [Integer] The storage limit for the database elastic pool in
      # bytes.
      attr_accessor :max_size_bytes

      # @return [ElasticPoolPerDatabaseSettings] The per database settings for
      # the elastic pool.
      attr_accessor :per_database_settings

      # @return [Boolean] Whether or not this elastic pool is zone redundant,
      # which means the replicas of this elastic pool will be spread across
      # multiple availability zones.
      attr_accessor :zone_redundant

      # @return [ElasticPoolLicenseType] The license type to apply for this
      # elastic pool. Possible values include: 'LicenseIncluded', 'BasePrice'
      attr_accessor :license_type

      # @return [Hash{String => String}] Resource tags.
      attr_accessor :tags


      #
      # Mapper for ElasticPoolUpdate class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ElasticPoolUpdate',
          type: {
            name: 'Composite',
            class_name: 'ElasticPoolUpdate',
            model_properties: {
              sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              max_size_bytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxSizeBytes',
                type: {
                  name: 'Number'
                }
              },
              per_database_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.perDatabaseSettings',
                type: {
                  name: 'Composite',
                  class_name: 'ElasticPoolPerDatabaseSettings'
                }
              },
              zone_redundant: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.zoneRedundant',
                type: {
                  name: 'Boolean'
                }
              },
              license_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.licenseType',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
