# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2018_06_01_preview
  module Models
    #
    # An Azure SQL instance pool.
    #
    class InstancePool < TrackedResource

      include MsRestAzure

      # @return [Sku] The name and tier of the SKU.
      attr_accessor :sku

      # @return [String] Resource ID of the subnet to place this instance pool
      # in.
      attr_accessor :subnet_id

      # @return [Integer] Count of vCores belonging to this instance pool.
      attr_accessor :v_cores

      # @return [InstancePoolLicenseType] The license type. Possible values are
      # 'LicenseIncluded' (price for SQL license is included) and 'BasePrice'
      # (without SQL license price). Possible values include:
      # 'LicenseIncluded', 'BasePrice'
      attr_accessor :license_type


      #
      # Mapper for InstancePool class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'InstancePool',
          type: {
            name: 'Composite',
            class_name: 'InstancePool',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              subnet_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.subnetId',
                type: {
                  name: 'String'
                }
              },
              v_cores: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.vCores',
                type: {
                  name: 'Number'
                }
              },
              license_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.licenseType',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
