# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SQL::Mgmt::V2017_10_01_preview
  module Models
    #
    # A database vulnerability assessment.
    #
    class DatabaseVulnerabilityAssessment < ProxyResource

      include MsRestAzure

      # @return [String] A blob storage container path to hold the scan results
      # (e.g. https://myStorage.blob.core.windows.net/VaScans/).  It is
      # required if server level vulnerability assessment policy doesn't set
      attr_accessor :storage_container_path

      # @return [String] A shared access signature (SAS Key) that has read and
      # write access to the blob container specified in 'storageContainerPath'
      # parameter. If 'storageAccountAccessKey' isn't specified,
      # StorageContainerSasKey is required.
      attr_accessor :storage_container_sas_key

      # @return [String] Specifies the identifier key of the storage account
      # for vulnerability assessment scan results. If 'StorageContainerSasKey'
      # isn't specified, storageAccountAccessKey is required.
      attr_accessor :storage_account_access_key

      # @return [VulnerabilityAssessmentRecurringScansProperties] The recurring
      # scans settings
      attr_accessor :recurring_scans


      #
      # Mapper for DatabaseVulnerabilityAssessment class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DatabaseVulnerabilityAssessment',
          type: {
            name: 'Composite',
            class_name: 'DatabaseVulnerabilityAssessment',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              storage_container_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageContainerPath',
                type: {
                  name: 'String'
                }
              },
              storage_container_sas_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageContainerSasKey',
                type: {
                  name: 'String'
                }
              },
              storage_account_access_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageAccountAccessKey',
                type: {
                  name: 'String'
                }
              },
              recurring_scans: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.recurringScans',
                type: {
                  name: 'Composite',
                  class_name: 'VulnerabilityAssessmentRecurringScansProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
